package dk.nsp.cbs.perf.http;

import java.io.IOException;
import java.nio.charset.StandardCharsets;

import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.util.EntityUtils;

public class HttpUtil {

  public static Response issueRequest(HttpClient httpClient, String body, String soapAction, String targetUrl) {
    final HttpPost post = new HttpPost(targetUrl);
    post.setEntity(new StringEntity(body, StandardCharsets.UTF_8));
    post.setHeader("Content-type", "text/xml; charset=utf-8");
    post.setHeader("SOAPAction", soapAction);

    try {
      final HttpResponse response = httpClient.execute(post);
      final String responseBody = EntityUtils.toString(response.getEntity());
      return new Response(responseBody, response.getStatusLine().getStatusCode());
    } catch (IOException e) {
      System.out.println("Error calling service :" + targetUrl);
      e.printStackTrace();
      return new Response(e.getMessage(), 500);
    }
  }
}
